library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity datapath is
     port(
		wrReg : in std_logic;
		selWr : in std_logic_vector(1 downto 0);
		selRd : in std_logic_vector(1 downto 0);
		switch_input : in std_logic_vector(3 downto 0);
		data_out : out std_logic_vector(7 downto 0);
		reset : in std_logic;
		clk : in std_logic
		);
end datapath ;


architecture behavioural of datapath is
	signal rf_out, data_bus_in : std_logic_vector(7 downto 0);
	type regarray is array(3 downto 0) of std_logic_vector(7 downto 0);
	signal rf: regarray;

begin
	data_bus_in <= "0000" & switch_input; 
	-- register file
	process (reset, clk) begin
		if(reset = '1' ) then
				rf ( 0 ) <= "11101110";
				rf ( 1 ) <= "11001110";
				rf ( 2 ) <= "00000010";
				rf ( 3 ) <= "01011001";
		elsif(clk'event AND clk='1') then
			if(wrReg = '1') then
				rf ( conv_integer(selWr) ) <= data_bus_in;
			end if;
		end if;
	end process;
	rf_out <= rf ( conv_integer(selRd) );

	data_out <= rf_out;
	
end behavioural;