

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
library work;
use work.all;

entity hw1B is
     port(
        key : in std_logic_vector(3 downto 0);  -- pushbutton switches
--        sw : in std_logic_vector(9 downto 0);  -- DE1 slide switches
        sw : in std_logic_vector(17 downto 0);  -- DE2 slide switches
        ledg : out std_logic_vector(7 downto 0); -- green LEDs
		ledr : out std_logic_vector(9 downto 0);
		hex0 : out std_logic_vector(6 downto 0);
		hex1 : out std_logic_vector(6 downto 0);
		hex2 : out std_logic_vector(6 downto 0);
		hex3 : out std_logic_vector(6 downto 0)
		);
		
end hw1B ;


architecture behavioural of hw1B is
	signal sw_in: std_logic_vector(3 downto 0);
	signal data_out: std_logic_vector(7 downto 0);
	
begin

	-- DE1 and DE2
	sw_in <= sw(3 downto 0);
	
	u0: datapath
		port map( 
			wrReg => sw(8),
			selWr => sw(7 downto 6),
			selRd => sw(5 downto 4),
			switch_input => sw_in,
			data_out => data_out,
			reset => not key(3),
			clk => not key(0)
			);
	ledg(7 downto 0) <= "00000000";
	
	h0: hex port map(i => data_out(3 downto 0),
					 o => hex0);
	h1: hex port map(i => data_out(7 downto 4),
					 o => hex1);
	h2: hex port map(i => sw_in(3 downto 0),
					 o => hex2);
	h3: hex port map(i => "0000",
					 o => hex3);
					
	ledr <= (others => '0');

end behavioural;