
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
library work;
use work.all;

entity hw1C is
     port(
        key : in std_logic_vector(3 downto 0);  -- pushbutton switches
--        sw : in std_logic_vector(9 downto 0);  -- DE1 slide switches
        sw : in std_logic_vector(17 downto 0);  -- DE2 slide switches
        ledg : out std_logic_vector(7 downto 0); -- green LEDs
		ledr : out std_logic_vector(17 downto 0);
		hex0 : out std_logic_vector(6 downto 0);
		hex1 : out std_logic_vector(6 downto 0);
		hex2 : out std_logic_vector(6 downto 0);
		hex3 : out std_logic_vector(6 downto 0)
		);
		
end hw1C ;


architecture behavioural of hw1C is
	signal sw_in: std_logic_vector(7 downto 0);
	signal data_out, alu_out, reg_out: std_logic_vector(7 downto 0);
	
begin

	-- DE2
	sw_in <= "0000" & sw(13 downto 10);
	ledr(17 downto 8) <= "0000000000";
	-- DE1
--	sw_in <= "00000000";
	
	u0: datapath
		port map( 
			wrReg => sw(8),
			selReg => sw(7 downto 6),
			selBus => sw(5 downto 4),
			wrA => sw(3),
			wrB => sw(2),
			ALUop => sw(1 downto 0),
			switch_input => sw_in,
			data_out => data_out,
			alu_out => alu_out,
			reg_out => reg_out,
			cc_out => ledg(5 downto 0),
			reset => not key(3),
			selLED => not key(2),
			clk => not key(0)
			);
	ledg(7 downto 6) <= "00";
	
	h0: hex port map(i => alu_out(3 downto 0),
					 o => hex0);
	h1: hex port map(i => alu_out(7 downto 4),
					 o => hex1);
	h2: hex port map(i => data_out(3 downto 0),
					 o => hex2);
	h3: hex port map(i => data_out(7 downto 4),
					 o => hex3);
					
	ledr(7 downto 0) <= reg_out;

end behavioural;
